//
//  NSImage-IconExtensions.m
//  SystemIconViewer
//
//  Created by Paul Kim on 3/17/06.
//  Copyright 2006 __MyCompanyName__. All rights reserved.
//

#import "NSImage-IconExtensions.h"
#import <Carbon/Carbon.h>

@implementation NSImage (IconExtensions)

- (NSImage *)initWithSystemIconType:(OSType)iconType
{
    OSStatus			err;
    IconRef				iconRef;
    IconFamilyHandle	iconFamily;
    NSData				*iconData;
	
	iconData = nil;
    err = GetIconRef(kOnSystemDisk, kSystemIconsCreator, iconType, &iconRef);
	if (err == noErr)
	{
		err = IconRefToIconFamily(iconRef, kSelectorAllAvailableData, &iconFamily);
		if (err == noErr)
		{
			iconData = [NSData dataWithBytes:*iconFamily length:GetHandleSize((Handle)iconFamily)];
			
			DisposeHandle((Handle)iconFamily);
		}
		else
		{
			NSLog(@"Could not get icon family.");
		}		
		
		ReleaseIconRef(iconRef);
	}
	else
	{
		NSLog(@"Could not get icon ref.");
	}
		
	if (iconData == nil)
	{
		NSLog(@"Could not load icon data.");
		[self release];
		return nil;
	}

    return [self initWithData:iconData];
}

@end
